/*
Created by: Peeyush
Created on: March 23 2022
Email: j.k.peeyush@gmail.com
Description: invoice update function
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////

//Invoice creation
const fs = require('fs')
const path = require('path')
const removeFile = (invnum, custnum, type) => {
    console.log(`Invoice_${invnum}_${custnum}_${type}.pdf`)
    try {
        if (fs.existsSync(path.join(__dirname, `../fs/Invoice_${invnum}_${custnum}_${type}.pdf`))) {
            fs.renameSync(path.join(__dirname, `../fs/Invoice_${invnum}_${custnum}_${type}.pdf`), path.join(__dirname, `../fsold/CANCELLED_${Date.now()}_Invoice_${invnum}_${custnum}_${type}.pdf`))
        } else {
            console.log('Invoice document not found');
        }
    } catch (error) {
        console.log(error);
    }
}
const updateInvoice = async (mapper, options, obj, bodySystem, auditFunc, DBredirects, audit_all_fields, system_user) => {
    console.log('Updating Invoice...')
    //get company detail for invoicing
    let update = ''
    let orderObj = obj;
    isnewrequired = false;
    let existingInvoices = (await DBredirects.findAllData(mapper.mapper.forModel('Invoice'), {
    }, {}, { consistency: options.consistency }))._rs.rows.filter(obj => {
        return obj.accntid == orderObj.Orders.accntid && obj.ordernum == orderObj.Orders.orderid && obj.status == 'NEW'
    })

    if (existingInvoices.length == 0) {
        console.log('No invoices are found')
        return "No invoices are found";
    } else {
        itemchanges = []
        existingInvoices.forEach(element => {
            switch (bodySystem) {
                case 'cancel':
                    element.status = 'CANCELLED'
                    removeFile(element.invid.replace(/\//g, '_'), element.ordernum.replace(/\//g, '_'), element.type)
                    break
                case 'complete':
                    element.status = 'FINAL'
                    break

                case 'edit':
                    element.status = 'CANCELLED'
                    removeFile(element.invid.replace(/\//g, '_'), element.ordernum.replace(/\//g, '_'), element.type)
                    break
            }

            element.updated = orderObj.Orders.update
            element.updatedby = orderObj.Orders.updatedby

            itemchanges.push(mapper.mapper.forModel('Invoice')
                .batching.update(element, { ifExists: true }
                    , { consistency: options.consistency }))
        });

        update = await mapper.mapper.batch(itemchanges);

        let value = { 'new_data': JSON.stringify(existingInvoices), 'action_result': JSON.stringify(update) }

        auditFunc(value, 'CURRENT', 'UPDATE', 'Invoice', audit_all_fields, mapper, DBredirects, options, system_user, 'Invoice');

        //create communication
        let msg = `Your invoice has been successfully updated.`
        let com = (
            await mapper.global.communicationEntry('INBOUND', existingInvoices[0].invid, orderObj.Orders.updatedby, msg, mapper, DBredirects, options, system_user)
        )
        //callback audit
        value = {
            'new_data': JSON.stringify(com.data),
            'action_result': JSON.stringify(
                com.rs
            )
        }
        auditFunc(value, 'CURRENT', 'CREATE', 'Communication', audit_all_fields, mapper, DBredirects, options, system_user, 'Communication')


    }
    console.log('Updating Invoice completed')
    return JSON.stringify(update)
}
module.exports = updateInvoice;