/*
Created by: Peeyush
Created on: May 19 2022
Email: j.k.peeyush@gmail.com
Description: Send mail over smtp
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
const nodemailer = require('nodemailer');
const { appendFile } = require('fs');
const path = require('path');

//prepare message
const processMsg = (msg) => {
    let prod = msg.products.split('\n')
    prod = prod.reduce((prev, curr, i) => {
        prev = prev + (i + 1) + '. ' + curr + '<br/>'
        return prev
    }, '')
    let m = `
    <p>Hi PRASI LABS,<br/><br/>${msg.message}<br/><br/>List of products:<br/>${prod}<br/><br/>Thanks & Regards,<br/>
    ${msg.name}<br/>${msg.company}<br/>${msg.email}<br/>${msg.phone}<br/>${msg.country}
    `
    return m
}

//email send function
const sendEmail = async (from, to, sub, messages, mapper) => {
    let transport = nodemailer.createTransport({
        host: mapper.global.ENV.EMAILSERVER,
        port: mapper.global.ENV.EMAILPORT,
        auth: {
            user: mapper.global.ENV.EMAILSERVERUSER,
            pass: mapper.global.ENV.EMAILSERVERPASSWORD
        }
    });


    const message = {
        from: from,
        to: to,
        subject: sub,
        html: messages instanceof Object ? processMsg(messages) : messages,
        /*    attachments: [{
                filename: "test-attachment.png",
                path: "https://homepages.cae.wisc.edu/~ece533/images/arctichare.png"
            }]*/
    };

    transport.sendMail(message, function (err, info) {
        if (err) {
            console.error(err)
            appendFile(path.resolve(mapper.global.ENV.MAILLOGFILE), err, { encoding: 'utf-8', mode: 0o666, flag: 'a' }, function (err) {
                if (err) {
                    console.error(err)
                }
            });
            return 'Something is wrong. Please contact us.'
        } else {
            console.info('Mail Success')
            appendFile(path.resolve(mapper.global.ENV.MAILLOGFILE), JSON.stringify(info), { encoding: 'utf-8', mode: 0o666, flag: 'a' }, function (err) {
                if (err) {
                    console.error(err)
                }
            })
                ;
            return 'You enquiry has been sent. If not answered within 24 hours, please contact us.'
        }
    });

}

module.exports = sendEmail;