/*
Created by: Peeyush
Created on: June 19 2022
Email: j.k.peeyush@gmail.com
Description: convert number to word
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
convertNumToWords = (num) => {
    let amount = ''
    const NWMap = {
        '0': '',
        '1': 'one',
        '2': 'two',
        '3': 'three',
        '4': 'four',
        '5': 'five',
        '6': 'six',
        '7': 'seven',
        '8': 'eight',
        '9': 'nine',
        '10': 'ten',
        '11': 'eleven',
        '12': 'tweleve',
        '13': 'thirteen',
        '14': 'fourteen',
        '15': 'fifteen',
        '16': 'sixteen',
        '17': 'seventeen',
        '18': 'eighteen',
        '19': 'ninteen',
        '100': 'hundred',
        '1000': 'thousand',
        '100000': 'lac',
        '10000000': 'crore'
    }

    if (Math.floor(num / 10000000) >= 1) {
        amount = amount + ' ' + ctow(Math.floor(num / 10000000)) + ' ' + NWMap['10000000']
        num = num % 10000000
    }

    if (Math.floor(num / 100000) >= 1) {
        amount = amount + ' ' + ctow(Math.floor(num / 100000)) + ' ' + NWMap['100000']
        num = num % 100000
    }

    if (Math.floor(num / 1000) >= 1) {
        amount = amount + ' ' + ctow(Math.floor(num / 1000)) + ' ' + NWMap['1000']
        num = num % 1000
    }

    if (Math.floor(num / 100) >= 1) {
        amount = amount + ' ' + ctow(Math.floor(num / 100)) + ' ' + NWMap['100']
        num = num % 100
    }

    if (num > 19) {
        amount = amount + ' ' + ctow(num)
    }

    if (num <= 19) {
        amount = amount + ' ' + NWMap[num]
    }

    return amount;
}

ctow = (num) => {
    let am = undefined
    if ((num).toString().length >= 3) {
        return am;
    }
    const NWMap = {
        '0': '',
        '1': 'one',
        '2': 'two',
        '3': 'three',
        '4': 'four',
        '5': 'five',
        '6': 'six',
        '7': 'seven',
        '8': 'eight',
        '9': 'nine',
        '10': 'ten',
        '11': 'eleven',
        '12': 'tweleve',
        '13': 'thirteen',
        '14': 'fourteen',
        '15': 'fifteen',
        '16': 'sixteen',
        '17': 'seventeen',
        '18': 'eighteen',
        '19': 'ninteen',
        '20': 'twenty',
        '30': 'thirty',
        '40': 'fourty',
        '50': 'fifty',
        '60': 'sixty',
        '70': 'seventy',
        '80': 'eighty',
        '90': 'ninghty',
    }

    // console.log(num)

    if (Math.floor(num / 90) >= 1) {
        am = (NWMap['90'] + ' ' + NWMap[num % 90])
    }
    else if (Math.floor(num / 80) >= 1) {
        am = (NWMap['80'] + ' ' + NWMap[num % 80])
    }

    else if (Math.floor(num / 70) >= 1) {
        am = (NWMap['70'] + ' ' + NWMap[num % 70])
    }

    else if (Math.floor(num / 60) >= 1) {
        am = (NWMap['60'] + ' ' + NWMap[num % 60])
    }

    else if (Math.floor(num / 50) >= 1) {
        am = (NWMap['50'] + ' ' + NWMap[num % 50])
    }

    else if (Math.floor(num / 40) >= 1) {
        am = (NWMap['40'] + ' ' + NWMap[num % 40])
    }

    else if (Math.floor(num / 30) >= 1) {
        am = (NWMap['30'] + ' ' + NWMap[num % 30])
    }

    else if (Math.floor(num / 20) >= 1) {
        am = (NWMap['20'] + ' ' + NWMap[num % 20])
    }
    else {
        am = NWMap[num]
    }
    return am;
}

module.exports = convertNumToWords