
/*
Created by: Peeyush
Created on: July 16 2021
Email: j.k.peeyush@gmail.com
Description: traverse JSON.
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
//Function to check specific key in the JSON hirarchy and return its value array
//output must be an array
const traveresKey = (
    //JSON object to traverse
    jsonObject,
    //key to search in JSON
    key,
    //return object for output
    output) => {
    'use strict';
    if (jsonObject === undefined || key === undefined || output === undefined || !(output instanceof Object)) {
        return null;
    }
    // console.log(jsonObject)
    if (jsonObject instanceof Object) {
        if (!jsonObject.hasOwnProperty(key)) {
            output.push('KEY_NOT_FOUND');
            return output;
        }

        for (let element = 0; element < Object.keys(jsonObject).length; element++) {
            if (jsonObject[element] instanceof Object)
                traveresKey(jsonObject[Object.keys(jsonObject)[element]], key, output);

            if (Object.keys(jsonObject)[element] == key) {
                output.push(jsonObject[key]);

                return output;
            }


        }
    } else {
        if (jsonObject === key) { output.push("") };
        return output;
    }
}

//Function to traveres JSON and return complete path key value object
//output shoud be an object
const traveres = (
    //JSON object to traverse
    jsonObject,
    //value path in the JSON object at calling point
    path,
    //output object to store
    output) => {
    'use strict';
    if (jsonObject === undefined || path === undefined || output === undefined || !(output instanceof Object)) {
        return null;
    }
    if (jsonObject instanceof Object) {
        for (let element = 0; element < Object.keys(jsonObject).length; element++) {
            traveres(jsonObject[Object.keys(jsonObject)[element]], path + '.' + Object.keys(jsonObject)[element], output);
        }
    } else {
        output[path] = jsonObject;
        return output;
    }
}

//Function to check specific key in the JSON hirarchy and return its value with complete path : value pair
//output should be an object 
const traveresKeyPath = ( //JSON object to traverse
    jsonObject,
    //key to search in JSON
    key,
    //value path in the JSON object at calling point
    path,
    //output object to store
    output) => {
    'use strict';
    if (jsonObject === undefined || key === undefined || path === undefined || output === undefined || !(output instanceof Object)) {
        return null;
    }
    if (jsonObject instanceof Object) {
        for (let element = 0; element < Object.keys(jsonObject).length; element++) {
            if (Object.keys(jsonObject)[element] === key) {
                let k = path ? path + '.' + key : key

                output[k] = jsonObject[Object.keys(jsonObject)[element]];
                return output;
            };
            traveresKeyPath(jsonObject[Object.keys(jsonObject)[element]], key, path + '.' + Object.keys(jsonObject)[element], output);
        }
    } else {
        if (jsonObject === key) { output[path ? path + '.' + key : key] = "" };
        return output;
    };
}

//Function to check specific key path in the JSON hirarchy and return its value in an array
// Path should be given in the format parent<sep>child<sep>...
//output must be an array
const traveresPath = (
    //JSON object to traverse
    jsonObject,
    //full key path
    key,
    //separator used to define full key path
    sep,
    //output object
    output) => {
    'use strict';
    if (jsonObject === undefined || key === undefined || sep === undefined || output === undefined || !(output instanceof Object) || sep.toString().length !== 1) {
        return null;
    }
    if (jsonObject instanceof Object && key.split(sep).length > 1) {
        if (jsonObject.hasOwnProperty(key.split(sep)[0])) {

            traveresPath(jsonObject[key.split(sep)[0]],
                key.substring(key.indexOf(key.split(sep)[1])),
                sep, output)
        }
        else {
            return null;
        }
    }
    else {
        if (jsonObject.hasOwnProperty(key.split(sep)[0])) {
            output.push(jsonObject[key.split(sep)[0]])
            return output
        }
        else {
            return null;
        }
    }
}

//Exporting functions to be available across modules when imported
exports.traveresKey = traveresKey
exports.traveres = traveres
exports.traveresKeyPath = traveresKeyPath
exports.traveresPath = traveresPath
