/*
Created by: Peeyush
Created on: July 14 2021
Email: j.k.peeyush@gmail.com
Description: Model definition of Account table in Cassandra DB
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
const dataType = require('express-cassandra');
//Account module definition
module.exports = {
    fields: {
        id: {
            type: "uuid",
            default: { "$db_function": "uuid()" }
        },
        customerid: "varchar",
        fullname: "varchar",
        email: "varchar",
        phone: "varchar",
        cemail: "varchar",
        cphone: "varchar",
        caddress: "text",
        uaddress: "text",
        cstate: "varchar",
        czip: "int",
        idtype: "varchar",
        idname: "varchar",
        idnum: "varchar",
        type: "varchar",
        compregno: "varchar",
        company: "varchar",
        uniqbusidenno: "varchar",
        uniqbusidentype: "varchar",
        buscountry: "varchar",
        contact: {
            type: "map",
            typeDef: "<varchar,varchar>"
        },
        address: {
            type: "map",
            typeDef: "<varchar,varchar>"
        },
        selfdeclation: {
            type: "boolean",
            default: "false"
        },
        status: "varchar",
        dob: "date",
        updatedby: "varchar",
        createdby: "varchar",
        created: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        updated: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        }
    },
    key: [["customerid"], "email", "id"],
    clustering_order: {"email": "asc", "id": "desc" },
}