/*
Created by: Peeyush
Created on: July 14 2021
Email: j.k.peeyush@gmail.com
Description: Model definition of Address table in Cassandra DB
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
//Address module definition
module.exports = {
    fields: {
        id: {
            type: "uuid",
            default: { "$db_function": "uuid()" }
        },
        status: "varchar",
        addressid: "varchar",
        type: "varchar",
        address: "text",
        ziplist: "varchar",
        updatedby: "varchar",
        createdby: "varchar",
        created: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        updated: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        }
    },
    key: [["addressid"], "id"],
    clustering_order: { "id": "asc"},
}