/*
Created by: Peeyush
Created on: July 14 2021
Email: j.k.peeyush@gmail.com
Description: Model definition of Audit table in Cassandra DB
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
//Audit module definition
module.exports = {
    fields: {
        id: {
            type: "uuid",
            default: { "$db_function": "uuid()" }
        },
        type: { type: "varchar" },
        operation: { type: "varchar" },
        tablename: {
            type: "varchar",
        },
        fieldname: {
            type: "varchar",
        },
        value: {
            type: "map",
            typeDef: "<varchar,text>"
        },
        updatedby: "varchar",
        createdby: "varchar",
        created: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        updated: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        }
    },
    key: [["id", "type"],"operation", "updated"],
    clustering_order: { "updated": "desc" },
}