/*
Created by: Peeyush
Created on: July 14 2021
Email: j.k.peeyush@gmail.com
Description: Model definition of Communication table in Cassandra DB
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
//Communication module definition
module.exports = {
    fields: {
        id: {
            type: "uuid",
            default: { "$db_function": "uuid()" }
        },
        commid: "varchar",
        type: { type: "varchar"},
        user: "varchar",
        message: { type: "text"},
        accntid: "varchar",
        updatedby: "varchar",
        createdby: "varchar",
        created: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        updated: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        }
    },
    key: [["accntid"],"updated", "id","commid"],
    clustering_order: { "updated": "desc","commid":"asc" },
}