
/*
Created by: Peeyush
Created on: Jan 29 2022
Email: j.k.peeyush@gmail.com
Description: Model definition of company in Cassandra DB
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
//Key module definition
module.exports = {
    fields: {
        updatedby: "varchar",
        createdby: "varchar",
        created: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        updated: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        id: {
            type: "uuid",
            default: { "$db_function": "uuid()" }
        },
        name: "varchar",
        address: "varchar",
        phone: "varchar",
        mobile: "varchar",
        fax: "varchar",
        idtype: "varchar",
        idnum: "varchar",
        country: "varchar",
        email: "varchar",
        defaultcurrency: "varchar",
        status: "varchar",
        registrationnum: "varchar",
        registrationdate: "date",
        license: {
            type: "set",
            typeDef: "<text>"
        }
    },
    key: [["id"]],
}
