
/*
Created by: Peeyush
Created on: July 14 2021
Email: j.k.peeyush@gmail.com
Description: Model definition of Invoice table in Cassandra DB
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
//Invoice module definition
module.exports = {
    fields: {
        updatedby: "varchar",
        createdby: "varchar",
        created: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        updated: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        id: {
            type: "uuid",
            default: { "$db_function": "uuid()" }
        },
        status: "varchar",
        invid: "varchar",
        type: "varchar",
        otherinfo: {
            type: "map",
            typeDef: "<varchar,text>"
        },
        bill: {
            type: "map",
            typeDef: "<varchar,text>"
        },
        ship: {
            type: "map",
            typeDef: "<varchar,text>"
        },
        waybillnum: "varchar",
        waybilldate: "varchar",
        item: {

            type: "list",
            typeDef: "<text>"
        },
        csgt: "float",
        sgst: "float",
        igst: "float",
        tax: "float",
        totalamount: "float",
        finalamount: "float",
        ordernum: "varchar",
        orderdate: "varchar",
        poordernum: "varchar",
        poorderdate: "date",
        quotenum: "varchar",
        quotedate: "date",
        ispo:"boolean",
        accntid: "varchar",
        invdate: "date",
        surcharge: "float",
        otherdiscount: "float",
        othercharges: "float",
        shippingcharges: "float",
        shippingdetail:"varchar",
        shipgst:"float",
        currency: "varchar",
        invmaildetail: {
            type: "map",
            typeDef: "<varchar,text>"
        }
    },
    key: [["accntid"], "ordernum", "invid", "type", "id"],
    clustering_order: { "id": "desc", "ordernum": "desc", "invid": "desc" },
}