
/*
Created by: Peeyush
Created on: Jan 23 2022
Email: j.k.peeyush@gmail.com
Description: Model definition of Order table in Cassandra DB
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
//Invoice module definition
module.exports = {
    fields: {
        updatedby: "varchar",
        createdby: "varchar",
        created: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        updated: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        id: {
            type: "uuid",
            default: { "$db_function": "uuid()" }
        },
        status: "varchar",
        type: "varchar",
        ordernum: "varchar",
        orderid: "varchar",
        itemamount: "float",
        taxamount: "float",
        taxrate: "float",
        cgstamount: "float",
        sgstamount: "float",
        prodid: "varchar",
        igstamount: "float",
        cgstrate: "float",
        sgstrate: "float",
        igstrate: "float",
        currency: "varchar",
        discount: "float",
        accntid: "varchar",
        itemdetail: {
            type: "map",
            typeDef: "<varchar,text>"
        },
        quantity: "float",
        unit: "varchar",
        itemprice: "float",
        itemname: "varchar",
        itemid: "varchar"
    },
    key: [["accntid"], "type", "itemid", "orderid", "ordernum", "id"],
    clustering_order: { "itemid": "desc", "orderid": "desc", "id": "desc" },
}