
/*
Created by: Peeyush
Created on: Jan 21 2022
Email: j.k.peeyush@gmail.com
Description: Model definition of Order table in Cassandra DB
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
//Invoice module definition
module.exports = {
    fields: {
        updatedby: "varchar",
        createdby: "varchar",
        created: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        updated: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        id: {
            type: "uuid",
            default: { "$db_function": "uuid()" }
        },
        status: "varchar",
        type: "varchar",
        direction: "varchar",
        orderid: "varchar",
        ordernum: "varchar",
        poordernum: "varchar",
        poorderdate: "date",
        quotenum: "varchar",
        quotedate: "date",
        orderamount: "float",
        bill: {
            type: "map",
            typeDef: "<varchar,text>"
        },
        ship: {
            type: "map",
            typeDef: "<varchar,text>"
        },
        taxamount: "float",
        cgstamount: "float",
        sgstamount: "float",
        igstamount: "float",
        discount: "float",
        insurenceamount: "float",
        shippingamount: "float",
        surcharge: "float",
        finalamount: "float",
        accntid: "varchar",
        currency: "varchar",
        shippingdetail: "text",
        shipgst:"float",
        revisionnum: "int",
        oredritemdetail: {
            type: "set",
            typeDef: "<varchar>"
        }
    },
    key: [["accntid"], "type", "orderid", "ordernum", "id"],
    clustering_order: { "ordernum": "desc", "orderid": "asc" },
}