
/*
Created by: Peeyush
Created on: July 14 2021
Email: j.k.peeyush@gmail.com
Description: Model definition of Product table in Cassandra DB
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
//Product module definition
module.exports = {
    fields: {
        id: {
            type: "uuid",
            default: { "$db_function": "uuid()" }
        },
        productname: "varchar",
        casno: "varchar",
        unitselltype: "varchar",
        prodid: "varchar",
        priceperunit: "float",
        quantity: "varchar",
        status: "varchar",
        type: "varchar",
        makecountry: "varchar",
        makecompany: "varchar",
        reactivity: "varchar",
        storgetype: "varchar",
        structure: "blob",
        chemicalformula: "varchar",
        chemicalname: "varchar",
        currency: "varchar",
        availabilitydate: "date",
        enddate: "date",
        otherinfo:{
            type: "map",
            typeDef: "<varchar,text>"
        },
        updatedby: "varchar",
        createdby: "varchar",
        created: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        updated: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        }
    },
    key: [["id"], "prodid"],
    clustering_order: { "prodid": "asc" },
}
