/*
Created by: Peeyush
Created on: July 14 2021
Email: j.k.peeyush@gmail.com
Description: Model definition of Service request table in Cassandra DB
Version: 1.0
Project: PRASI Labs
Security: Confidential
License: NA
*/
////////////////////////////////////////////////////////////////////////////////////////////////////
//Service request module definition
module.exports = {
    fields: {
        id: {
            type: "uuid",
            default: { "$db_function": "uuid()" }
        },
        updatedby: "varchar",
        createdby: "varchar",
        created: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        },
        updated: {
            type: "timestamp",
            default: { "$db_function": "toTimestamp(now())" }
        }
        , status: "varchar",
        srno: "varchar",
        accntid: "varchar",
        type: "varchar",
        interaction: {
            type: "map",
            typeDef: "<timestamp,text>"
        }
    },
    key: [["accntid"], "srno", "type","id"],
    clustering_order: { "srno": "asc", "id": "desc" },
}